void draw()
{
  // refresh background every frame
  background(bgColor);
  textAlign(RIGHT, CENTER);
  textFont(myFont1);
  text("Awake - Empirical hours of the library RE-ORDERED [2006]", 1100, 40);
  //creating the cells sequentially
  // this where the actual drawing of data happens 
  // we run two nested loops, one for rows and the other for columns , we go through each cell to retrive its value 
  // and fill the color of the cell accordingly
  for ( int  i = 0; i<  numWeeks; i++) 
  {
    for ( int  j = 0; j < numWeekdays; j++)           // -1 as the last column is empty, our dataMatrix is smaller than the table by one column
    {                    
      colorMode(HSB);
//      stroke(1, 192, 224* dataWeekdayByAwake[i][j]/numWeekdays, 224* dataWeekdayByAwake[i][j]/numWeekdays );
      stroke(1, 192, 224* dataAwakeByAwake[i][j]/maxAwake, 224* dataAwakeByAwake[i][j]/maxAwake );
      strokeWeight(1);
      fill(bgColor); // fill boxes with same color as background
      //plot 24 hour rectangle with stroke around it
      rect(rowMargin + i * cellWidth, colMargin + j * cellHeight, cellWidth-2, cellHeight);//*;

//      fill(150+92* dataWeekByAwake[i][j]/numWeeks, 192, 192);
      colorMode(RGB);
      fill(colorWeekday[floor(dataWeekByAwake[i][j])/(numWeekdays+1)]);
//      fill(colorWeekday[dataWeekdayByAwake[i][j]-1]);
      //Fig.1
      //colorMode(HSB);
      //      fill(1, 192, 224* dataAwakeByAwake[i][j]/maxAwake, 224* dataAwakeByAwake[i][j]/maxAwake );
      //colorMode(RGB);
      factHeight = (float)(dataLatestCout[i][j]-dataEarliestCout[i][j])/24;//hours dependent scaling factor for height
      morningOffset = (float)dataEarliestCout[i][j]/24 * cellHeight;
      //plot rectangle that is mapped onto the area of the observed hours
      rect(rowMargin + i * cellWidth, colMargin + j * cellHeight + morningOffset, cellWidth-2, cellHeight*factHeight);//*;
    }
  }

  textAlign(RIGHT, CENTER);
  textFont(myFont2, 12);  
  fill(154);            
  for (int i=0; i<numWeekdays; i++) {
    //text(weekdayNames[i], rowMargin * 0.91, colMargin + cellHeight/2 + i*cellHeight);
    text("awakeClass "+ (i+1), rowMargin * 0.91, colMargin + cellHeight/2 + i*cellHeight);
  }
  
  drawColorBar();

  if ( frameCount % 20 ==0)
  {
    println( "draw called " + frameCount );                    // here we are printing out the frameCount ( how many frames have been drawn so far)
  }
}

void drawColorBar() {
  colorMode(RGB);  
    for(int j = 0; j < 7; j++) {
          stroke(colorWeekday[j]);
          fill(colorWeekday[j]);
          rect(rowMargin+925+j*35, colMargin+375, 25, 20);
          textFont(myFont2, 11);
          textAlign(LEFT, CENTER);
          text(weekdayNamesShort[j], rowMargin+925+j*35+6.25, colMargin+405);
      }   
}
